// ChessBoard.h: interface for the ChessBoard class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _CHESSBOARD_H_
#define _CHESSBOARD_H_

#include "ChessPiece.h"

class ChessPieceSet;
class ChessMove;


typedef struct tagChessBoardSquare{
  ChessPiece *piece;
  bool isBlack;
  char getCol(){ return piece->getCol(); };// will the piece row and col ever 
  char getRow(){ return piece->getRow(); };// be diff't from the square true 
                                           // row and col..?
} ChessBoardSquare;


class ChessBoard
{
public:
  ChessBoard();
  virtual ~ChessBoard();
  
  bool initialize();
  void print();
	
  enum{ NUM_ROWS = 8 }; // size of the board
  enum{ NUM_COLS= 8 };
  
  ChessPieceSet *whitePieces;
  ChessPieceSet *blackPieces;
  
  bool movePiece(ChessMove *move, bool isBlackPiece);
  
  // test that <move> is valid on this board
  bool isValidMove(ChessMove *move);
  ChessBoardSquare* findFromSquare(ChessMove *move, bool isBlack) const;
  ChessBoardSquare* getSquare(long row, char col) const{ return squares[row-1][col-97]; }	
  
private:
  void setSquarePointer(ChessPiece *piece, bool isBlack);
  void clearSquares();
  void clearSquare(int row, char col);
  void resetSquaresFromPieces();
  
  // each location points into the ChessPieceSets
  // or NULL if contains no piece	
  ChessBoardSquare *squares[NUM_ROWS][NUM_COLS];
  
};

#endif // _CHESSBOARD_H_
