// ChessGame.h: interface for the ChessGame class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _CHESSGAME_H_
#define _CHESSGAME_H_

#include <string>

class ChessPlayer;
class ChessBoard;
class ScriptingEngine;

using namespace std;

class ChessGame  
{
public:
  ChessGame();
  virtual ~ChessGame();
  bool init(int argc, char **argv);
  void reset();
  
  void start();
  void gameLoop();	
  ScriptingEngine *scriptingEngine;
  bool isOK() const { return OK; }
private:
  ChessPlayer *whitePlayer;
  ChessPlayer *blackPlayer;
  ChessBoard *chessBoard;
  void parseCommandLineArgs(int argc, char **argv);
  
  string whiteGamePath;
  string blackGamePath;

  const string baseGamePath;
  const string commonGamePath;
	
  const string whiteClassName;
  const string blackClassName;
  string whitePlayerClass;
  string blackPlayerClass;
  bool OK;

};

#endif // _CHESSGAME_H_
