//
// ChessMove.h
//

#ifndef _CHESSMOVE_H_
#define _CHESSMOVE_H_

#include <jni.h>
#include "JavaCPP.h"

// provides a wrapper around the jobject
// returned by ScriptController->nextMove();
class ChessMove  
{
public:
  ChessMove();
  ChessMove(char *move); // <move> defines a move in algeabraic notation
  virtual ~ChessMove();	
  
  // convert this class into the algeabraic
  // representation of a chess move
  char *toAlgeabraicMove();
  
  // convert this class to a JChessMove java object
  jobject toJNIObject(JavaCPP *jvm); 
  
  // accessors	
  long getRow(){ return row; }
  char getCol(){ return col; }
  long getFromRow(){ return fromRow; }
  char getFromCol(){ return fromCol; }
  bool getIsCapture(){ return isCapture; }
  bool getIsCheck(){ return isCheck; }
  bool getIsCheckMate(){ return isCheckMate; }
  bool getIsLongCastle(){ return isShortCastle; }
  bool getIsShortCastle(){ return isLongCastle; }
  char getPiece(){ return piece; }
  
  void setCol(char col);
  void setRow(long row);
  void setIsCapture(bool isCapture);
  void setIsCheck(bool isCheck);
  void setIsCheckMate(bool isCheckMate);
  void setIsCastleShort(bool isCastleShort);
  void setIsCastleLong(bool isCastleLong);
  void setPiece(char piece);	
  
  
private:
  char col;
  long row;
  char fromCol;
  long fromRow;
  char piece;
  bool isCapture;
  bool isCheck;
  bool isCheckMate;
  bool isLongCastle;
  bool isShortCastle;
  
};


#endif // _CHESSMOVE_H_
