//
// ChessPiece.cpp
//


#include "ChessPiece.h"
#include "debug.h"


ChessPiece::ChessPiece(int type, int row, char col)
{
  this->type = type;
  this->row = row;
  this->col = col;
}

//////////////////////////////////////////////////////////////////////

ChessPiece::ChessPiece(ChessPiece &piece)
{
  this->type = piece.getType();
  this->row = piece.getRow();
  this->col = piece.getCol();
}

//////////////////////////////////////////////////////////////////////

ChessPiece::~ChessPiece()
{

}

//////////////////////////////////////////////////////////////////////

bool ChessPiece::isOnSquare(int row, char col)
{
  return (this->row == row && this->col == col);
}

//////////////////////////////////////////////////////////////////////

bool ChessPiece::isOnRow(long row)
{
  return this->row == row;
}

//////////////////////////////////////////////////////////////////////

bool ChessPiece::isOnCol(char col)
{
  return this->col == col;
}

//////////////////////////////////////////////////////////////////////

bool ChessPiece::operator==(ChessPiece &rhs) const
{
  dprintf(("entered ChessPiece::operator==\n"));
  return (type == rhs.getType()) && (row == rhs.getRow())	
    && (col == rhs.getCol());
  //return false;
}

//////////////////////////////////////////////////////////////////////

