//
// ChessPiece.h
//


#ifndef _CHESSPIECE_H_
#define _CHESSPIECE_H_

#include <list>

using namespace std;

class ChessPiece  
{
public:
  ChessPiece(int type, int row, char col);
  ChessPiece(ChessPiece &piece);
  virtual ~ChessPiece();
  
  char getType(){ return type; };
  long getRow(){ return row; };
  char getCol(){ return col; };
  void setSquare(int row, char col){ this->row = row; this->col = col; }
  bool isOnSquare(int row, char col);
  bool isOnRow(long row);
  bool isOnCol(char col);
  bool isthistrue();
  
  enum piece_types{
    PAWN	= 'P',
    ROOK	= 'R',
    BISHOP	= 'B',
    KNIGHT	= 'N',
    QUEEN	= 'Q',
    KING	= 'K'
  };

  bool operator==(ChessPiece &rhs) const;
  
  
private:
  char type;
  long row;
  char col;
};

typedef list<ChessPiece *> ChessPieceList;


#endif // _CHESSPIECE_H_
