//
// ChessPieceSet.h
//

#ifndef _CHESSPIECESET_H_
#define _CHESSPIECESET_H_

#include "ChessPiece.h"

class ChessPieceSet  
{
public:
  ChessPieceSet();
  virtual ~ChessPieceSet();
  bool initialize(bool isBlack); // if not black then white
  
  
  static const int NUM_PAWNS;
  static const int NUM_ROOKS;
  static const int NUM_KNIGHTS;
  static const int NUM_BISHOPS;
  static const int NUM_QUEENS;
  static const int NUM_KINGS;
  
  ChessPieceList* getPawns(){ return pawns; }
  ChessPieceList* getRooks(){ return rooks; }
  ChessPieceList* getKnights(){ return knights; }
  ChessPieceList* getBishops(){ return bishops; }
  ChessPiece* getQueen(){ return queen; }
  ChessPiece* getKing(){ return king; }
  
  ChessPieceList *pawns;
  ChessPieceList *rooks;
  ChessPieceList *knights;
  ChessPieceList *bishops;
  ChessPiece *queen;
  ChessPiece *king;
  
  bool removePiece(ChessPiece *piece);
  

};

#endif // _CHESSPIECESET_H_
