//
// ChessPlayer.cpp
//


#include "ChessPlayer.h"
#include "ChessMove.h"
#include "ScriptController.h"



ChessPlayer::ChessPlayer()
{
  scriptController = NULL;
  name = "noname";
}

ChessPlayer::ChessPlayer(string name)
  : name(name)
{
  scriptController = NULL;
}

ChessPlayer::~ChessPlayer()
{
  delete scriptController;
}

bool ChessPlayer::initialize(ScriptController *controller)
{
  this->scriptController = controller;
  return controller->initialize();
}

ChessMove* ChessPlayer::getNextMove(ChessMove *oppPrevMove)
{	
  ChessMove *move = scriptController->getNextMove(oppPrevMove);
  return move;	
}

void ChessPlayer::setName(const string &name)
{
  this->name = name;
}

void ChessPlayer::getName(string &name) const
{	
  name = this->name;
}
