// JChessMove.java

package players.common;

public class JChessMove
{
    public JChessMove()
    {
	row = -1;
	col = new String(); // should i set this to NULL ?
	isCapture = false;
	isCheck = false;
	isCheckMate = false;
	isShortCastle = false;
	isLongCastle = false;
	piece = 0;	
	fromRow = 0;
	fromCol = null;
    }

    /////////////////////////////////////////////////////////////////

    /*
    ** takes a string which represents a chess move
    ** defined by the algeabraic system
    ** <insert a reference>
    */
    public JChessMove(String move)
    {
	//System.out.println("entered JChessMove(" + move + ")");
	
	if(move == null) return;

	if(move.equals("O-O")){
	   isShortCastle = true;
	   return;
	}
	if(move.equals("O-O-O")){
	   isLongCastle = true;
	   return;
	}	
    
	StringBuffer str = new StringBuffer(move);
	int pos = 0;
	switch(str.charAt(pos)){
	case KNIGHT: 
	    piece = KNIGHT; pos++; break;
	case ROOK:
	    piece = ROOK; pos++; break;
	case BISHOP:
	    piece = BISHOP; pos++; break;
	case QUEEN:
	    piece = QUEEN; pos++; break;
	case KING:
	    piece = KING; pos++; break;
	default:
	    piece = PAWN; // no need to advance pos 	    
	    break;
	}
    
	//System.out.println("piece: " + (piece == 0 ? 'P' : piece));
	char fromCol = str.charAt(pos);
	if((fromCol == 'a' || fromCol == 'b' || fromCol == 'c' || 
	   fromCol == 'd' || fromCol == 'e' || fromCol == 'f' ||  
	   fromCol == 'g' || fromCol == 'h') && move.length() >= 4){
	    this.fromCol = str.substring(pos, pos+1);
	    pos++;
	    System.out.println("fromCol: " + fromCol);
	}

	
	if(Character.getType(str.charAt(pos)) == 
	   Character.DECIMAL_DIGIT_NUMBER && move.length() >= 4){
	    long fromRow = 
		Long.valueOf(new String(str.substring(pos,pos+1))).longValue();
	    if(0 <= fromRow || fromRow <= 8){
		this.fromRow = fromRow;
		pos++;
		System.out.println("fromRow: " + fromRow);
	    }
	}

	if(str.charAt(pos) == 'x'){
	    isCapture = true;
	    pos++;
	}
	
	col = str.substring(pos, pos+1);	
	pos++;
	row = Long.valueOf(new String(str.substring(pos, pos+1))).longValue();
	pos++;
		
	if(pos < move.length()){
	    if(str.substring(pos, pos+1).equals("+"))
		isCheck = true;
	    else if(str.substring(pos, pos+1).equals("#"))
		isCheckMate = true;
	    else if(str.substring(pos, pos+2).equals("++"))
		isCheckMate = true;

	}

	//System.out.println("leaving JChessMove( " + move + " )");
    }    

    /////////////////////////////////////////////////////////////////

    public String toAlgeabraicMove(){
	//System.out.println("entered JChessMove.toAlgeabraicMove()");
	
	if(isLongCastle) return "O-O-O";

	if(isShortCastle) return "O-O";

	StringBuffer str = new StringBuffer(6);	
		    
	if(piece != PAWN){
	    str.append(piece);      
	}

	if(fromCol != null){
	    str.append(fromCol);
	}

	if(fromRow != 0){
	    str.append(fromRow);
	}
    
	if(isCapture){
	    str.append('x');	          
	}    
	str.append(col);    
	str.append(Long.toString(row));    	

	
	if(isCheck == true) str.append("+");
	else if(isCheckMate == true) str.append("++");
	//System.out.println("leaving JChessMove.toAlgeabraicMove()");
	return new String(str);
    }

    /////////////////////////////////////////////////////////////////    

    // should i make these private and provide accessors...?
    public long fromRow;
    public String fromCol;
    public long row; // long is more standard than int on the native side
    public String col; // a single character string
    public boolean isCapture;
    public boolean isCheck;
    public boolean isCheckMate;
    public boolean isShortCastle;
    public boolean isLongCastle;
    public char piece;
    
    
    static final char KING = 'K';
    static final char QUEEN = 'Q';
    static final char ROOK = 'R';
    static final char BISHOP = 'B';
    static final char KNIGHT = 'N';
    static final char PAWN = 'P';

}
