// WhitePlayerAI.java
//
// white always serves as the _server_ in a peer2peer game
//

package players.peer2peer;

import players.common.*;
import java.net.*;
import java.io.*;

class WhitePlayerAI implements ChessPlayerAI
{

    ServerSocket serverSocket = null;
    Socket socket = null;
    BufferedReader reader  = null;
    BufferedWriter writer = null;
    
    public WhitePlayerAI() throws Exception
    {		
	serverSocket = new ServerSocket(5916);
    }

    /////////////////////////////////////////////////////////
    
    public boolean initialize() throws Exception
    {		
	System.out.println("awaiting connection...");
	socket = serverSocket.accept();	
	System.out.println("got connecion...");       

	reader = 
	    new BufferedReader(new InputStreamReader(socket.getInputStream()));
	writer = 
	    new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
		
	// perform some sort of handshake

	return true;	
    }
   
    /////////////////////////////////////////////////////////
    
    public int shutDown() throws Exception
    {
	serverSocket.close();
	socket.close();
	return 0;
    }

    /////////////////////////////////////////////////////////

    public JChessMove getNextMove(JChessMove move) throws Exception
    {	
	String moveStr = (move == null ? null : move.toAlgeabraicMove());
	
	System.out.println("WhitePlayerAI.getNextMove(" + 
			   (moveStr == null ? "null" : moveStr) + ")");
	
	if(move != null){
	    System.out.println("writing...");	    
	    writer.write(moveStr, 0, moveStr.length());
	    writer.newLine();
	    writer.flush();
	}
       		
	String peerMove;
	boolean done = false;
	do{
	    System.out.println("reading...");
	    peerMove = reader.readLine();
	    if(peerMove.length() != 0 || peerMove.charAt(0) == 'q') 
		done = true;
	}while(!done);

	System.out.println("done...");
	return peerMove.charAt(0) == 'q' ? null : new JChessMove(peerMove);

    }

    /////////////////////////////////////////////////////////

} // end claass WhitePlayerAI
