//
// ScriptController.h
//

#ifndef _SCRIPTCONTROLLER_H_
#define _SCRIPTCONTROLLER_H_

#include <jni.h>
#include "JavaCPP.h"
#include <string>

class ChessMove;
class JObject;

using namespace std;

typedef struct tagJavaMethodSigs{
	
  tagJavaMethodSigs() 
    : getNextMove("(Lplayers/common/JChessMove;)Lplayers/common/JChessMove;"),
    constructor("()V"),
    shutdown("()I"),
    initialize("()Z")
  { ; } 
  
  char *getNextMove;
  char *constructor;
  char *shutdown;
  char *initialize;
	
} JavaMethodSigs;


class ScriptController  
{
public:	
  ScriptController(JavaCPP *jcpp, const string &className);
  virtual ~ScriptController();
  
  bool initialize();	
  ChessMove *getNextMove(ChessMove *oppPrevMove);
  JavaCPP *getJavaCPP(){ return jcpp; }
  bool isInitialized(){ return initialized; }
  
 private:
  JavaMethodSigs methodSigs;
  JObject *obj;
  JavaCPP *jcpp;
  jmethodID getNextMoveID;	
  bool initialized;
  string className;
  
};

#endif // _SCRIPTCONTROLLER_H_
