//
// ScriptingEngine.h
//


#ifndef _SCRIPTINGENGINE_H_
#define _SCRIPTINGENGINE_H_

#include <jni.h>
#include "JavaCPP.h"
#include <string>

class ScriptController;

using namespace std;

class ScriptingEngine  
{
public:
  ScriptingEngine();
  virtual ~ScriptingEngine();
  bool init(const string &whiteGamePath, const string &blackGamePath);
  void reset();
  
  ScriptController *newScriptController(const string &className);
  
  bool isOK() const { return OK; }
private:
  bool OK;
  bool isInitialized;  
  JavaCPP *jcpp;
  bool createJavaVM(JavaVMOption *options, int numOptions);
  int addOption(JavaVMOption *options, const string &str, void *info);
};

#endif // _SCRIPTINGENGINE_H_
