#
# common variables and targets used in all make files
# 

# Several symbols with special meaning
# The following macro should contain TWO empty lines
define NEWLINE


endef
COMMA=,
EMPTY=
SPACE=$(EMPTY) $(EMPTY)
SEPARATOR=$"*-------------------------------------------------------------------------*$"

# Unix shells tend to use "$" as delimiter for variable names.
# Test for this behaviour and set $(BUCK) variable correspondigly ...
__TMP__:=$(shell echo $$$$)
ifeq ($(__TMP__),$$$$)
  BUCK = $$
else
  BUCK = \$$
endif

define UPD
  cmp -s $@ DEST || (rm -f DEST && cp $@ DEST)
  rm -f $@
endef

# Macro used to build a subtarget
define MAKE_TARGET
  @echo $(SEPARATOR)
  @echo $"  Compiling $(DESCRIPTION.$@)$"
  @echo $"  Compiling for $(OS)/$(COMP)/$(PROC) in $(MODE) mode$"
  @echo $(SEPARATOR)
  $(MAKE) $(RECMAKEFLAGS) -f projects/javacpp.mak $@
endef

# Macro used to make a sub-clean target
define MAKE_CLEAN
  @echo $(SEPARATOR)
  @echo $"  Cleaning up the $(DESCRIPTION.$(subst clean,,$@))$"
  @echo $(SEPARATOR)
  @$(MAKE) $(RECMAKEFLAGS) -f projects/javacpp.mak $@
endef

#--------------------------------------------

#<<=$<

# crystal space uses this like...
# Use $(^^) instead of $^ when you need all dependencies except libraries
# Use $(^^) instead of $^ when you need all dependencies except libraries
#^^=$(filter-out %memdbg$O,$(filter-out %$(LIB_SUFFIX),$^))
#^^=$^


#CFLAGS = 
#CFLAGS.INCLUDE += $(CFLAGS.I). $(CFLAGS.I)$(HOME)/include \
$(CFLAGS.I)./include $(CFLAGS.I)/usr/local/include


#LFLAGS.DLL =

#ARFLAGS=cr


# Typical prefix for library filenames

# Typical extension for dynamic libraries on this system.
#DLL=.so
# Typical extension for static libraries
#LIB_SUFFIX=.a
#LIB_PREFIX=lib

# How to compile a source files
#DO.COMPILE.C = $(CC) $(CFLAGS.@) -c $(<<) $(CFLAGS) $(CFLAGS.INCLUDE)
#DO.COMPILE.CPP = $(CXX) $(CFLAGS.@) -c $(<<) $(CFLAGS) $(CFLAGS.INCLUDE)
# How to make a static library
#DO.STATIC.LIBRARY = $(AR) $(ARFLAGS) $(ARFLAGS.@) $(^^)
# How to make a shared/dynamic library
#DO.SHARED.LIBRARY = $(LINK) $(LFLAGS.DLL) $(LFLAGS.@) $(^^) $(L^) $(LIBS) $(LFLAGS)






