//debugset.h
//Edit this file to change debug settings.
//There's no need to include this anyplace else -
//it's already included where it needs to be.

//Copyright 1999, Ian Parberry.  All rights reserved.

#ifndef __DEBUGSET_H__
#define __DEBUGSET_H__


#if defined(DEBUG)
  #define DEBUG_ON //define this for debugging, comment out to turn off
#endif // DEBUG

// turn off debugging if VisualC is in Release mode
#ifdef WIN32
  #ifdef NDEBUG
	#undef DEBUG_ON
  #endif
#endif

//output modes, select any or all

#ifdef DEBUG_ON
	#define DEBUG_OUTPUT_TO_FILE //define for debug output to file
	//#define DEBUG_OUTPUT_TO_DEBUGGER //define for debug output to windows debugger
	//#define DEBUG_OUTPUT_TO_COMPORT //define for debug output to COM port
  //#define DEBUG_OUTPUT_TO_IP //define for debug output to network
#endif

//settings for output modes

#ifdef DEBUG_OUTPUT_TO_FILE
  #define DEBUG_FILENAME "debug.txt" //file for debug output
#endif

#ifdef DEBUG_OUTPUT_TO_COMPORT
  #define DEBUG_SERIALPORT "COM2" //serial port for debug output
#endif


#ifdef DEBUG_OUTPUT_TO_IP
  #define DEBUG_IPADDR "129.120.36.31" //ip address of client
  #define DEBUG_PORT 1617 //port number, must agree with client
#endif

#endif //__DEBUGSET_H__
