
DESCRIPTION.jcpp = JavaCPP library

#------------------------------------------------------------ rootdefines ---#
ifeq ($(MAKESECTION),rootdefines)
include src/unix/jcpp_unix.mak

# Library-specific help commands
LIBHELP += $(NEWLINE)echo $"  make jcpp       Make the $(DESCRIPTION.jcpp)$"

endif # ifeq ($(MAKESECTION),rootdefines)

#------------------------------------------------------------ roottargets ---#
ifeq ($(MAKESECTION),roottargets)
#include src/unix/jcpp_unix.mak

.PHONY: jcpp

all libs: jcpp
jcpp:	
	$(MAKE_TARGET)
jcppclean:
	$(MAKE_CLEAN)

endif # ifeq ($(MAKESECTION),roottargets)

#------------------------------------------------------------ postdefines ---#
ifeq ($(MAKESECTION),postdefines)
include src/unix/jcpp_unix.mak

#vpath %.cpp src/jcpp
vpath %.cpp src/

JCPP.LIB = $(OUT)$(LIB_PREFIX)jcpp$(LIB_SUFFIX)
#SRC.jcpp = $(wildcard src/*.cpp) $(wildcard src/$(OS)/*.cpp)
SRC.jcpp = $(wildcard src/*.cpp) $(addprefix unix, $(wildcard src/unix/*.cpp))
OBJ.jcpp := $(addprefix $(OUT),$(notdir $(SRC.jcpp:.cpp=$O)))

CFLAGS.INCLUDE += $(CFLAGS.I)$(JDKHOME)/include $(CFLAGS.I)$(JDKHOME)/include/linux
CFLAGS.SYSTEM += $(CFLAGS.D)OS_UNIX

TO_INSTALL.STATIC_LIBS += $(JCPP.LIB)

endif # ifeq ($(MAKESECTION),postdefines)

#---------------------------------------------------------------- targets ---#
ifeq ($(MAKESECTION),targets)
include src/unix/jcpp_unix.mak

.PHONY: jcpp jcppclean

all: $(JCPP.LIB)
jcpp: $(OUTDIRS) $(JCPP.LIB)
clean: jcppclean


$(JCPP.LIB): $(OBJ.jcpp)
	$(DO.LIBRARY)
	$(CP) $(@) ./libs

# these command are very temporary *******
	$(CP) $(wildcard src/*.h) ./include
	mkdir ./include/unix
	$(CP) $(wildcard src/unix/*.h) ./include/unix


jcppclean:
	-$(RM) $(JCPP.LIB) $(OBJ.jcpp)
	rm -fr src/JavaCPP_*.*
	rm -fr ./include/unix


ifdef DO_DEPEND
dep: $(OUTOS)jcpp.dep
$(OUTOS)jcpp.dep: $(SRC.jcpp)
	$(DO.DEP)
else
-include $(OUTOS)jcpp.dep
endif

endif # ifeq ($(MAKESECTION),targets)
