//
// JavaCPP_unix.cpp
//


#include "JavaCPP_unix.h"
#include <dlfcn.h>
#include <cstring>
#include <cstdlib>
#include <sys/types.h>
#include <sys/stat.h>

#include "../debug.h"
//#define dprintf(N)

//extern inline char *strCombine(char* str, char* str2);

#define	RELEASE_1_3 "1.3"
#define	RELEASE_1_2 "1.2"
#define JVM_DLL     "libjvm.so"
#define JAVA_DLL    "libjava.so"

//////////////////////////////////////////////////////////////////////////////


JavaCPP_unix::JavaCPP_unix()
{  
  jvmLib = NULL;
}

//////////////////////////////////////////////////////////////////////////////

JavaCPP_unix::~JavaCPP_unix()
{	
  dprintf(("entered ~JavaCPP_unix()\n"));
  // superclass should call reset()
  dprintf(("leaving ~JavaCPP_unix()\n"));
}

void JavaCPP_unix::reset()
{
  dprintf(("entered JavaCPP_unix::reset()\n"));
  if(jvmLib) dlclose(jvmLib);
  jvmLib = NULL;
  dprintf(("entered JavaCPP_unix::reset()\n"));
}
//////////////////////////////////////////////////////////////////////////////


bool JavaCPP_unix::getJNIFuncHandles()
{
  // get the base path of the library
  if(!getJREHome(jreHome, sizeof(jreHome))) return false;
  dprintf((" ** %s\n", jreHome));
  
  if(getJVMType() < 0) return false;
  dprintf(("  jvmType: %s\n", jvmType));
  
  // load library	
  char buf[256];	 
  sprintf(buf, "%s/%s/%s", jreHome, jvmType, JVM_DLL);
  
  dprintf(("  loading library: %s\n", buf));
  jvmLib = dlopen(buf, RTLD_LAZY);			
  if(jvmLib == NULL){
    dprintf((dlerror()));
    return false;
  }
  
  jniFunctions.CreateJavaVM = (jint (JNICALL *)(JavaVM **, void **, void*))
    dlsym(jvmLib, "JNI_CreateJavaVM");  
  const char *dlerr = dlerror();
  if(dlerr != NULL){
    dprintf((dlerr));
    return false;
  }
  
  return true;
}



///////////////////////////////////////////////////////////////////////////////

// return whether we have to hotspot or
// classic virtual machine
int JavaCPP_unix::getJVMType()
{
  dprintf(("entered JavaCPP_unix::getJVMType()\n"));
	
  struct stat s;
  sprintf(jvmDll, "%s/hotspot/%s", jreHome, JVM_DLL);
  if (stat(jvmDll, &s) == 0){
    strncpy(jvmType, "hotspot\0", 8);
    return iJavaCPP::JVM_HOTSPOT;
  }

  sprintf(jvmDll, "%s/classic/%s", jreHome, JVM_DLL);
  if (stat(jvmDll, &s) == 0) {		
    strncpy(jvmType, "classic\0", 8);		
    return iJavaCPP::JVM_CLASSIC;
  }
		
  dprintf(("leaving JavaCPP_unix::getJVMType(): -1\n"));
  return -1;

}


///////////////////////////////////////////////////////////////////////////////

bool JavaCPP_unix::getJREHome(char *buf, int bufsize)
{  
  char *home = getenv("JREHOME");
  if(!home) return false;
  strncpy(buf, home, bufsize);	  
  return true;
}
