//
// iJavaCPP.h
//

#ifndef _I_JAVACPP_H_
#define _I_JAVACPP_H_

#include <jni.h>

class JObject;

//////////////////////////////////////////////////////////////////////////////

#define JNI_VERSION JNI_VERSION_1_2

typedef struct tagJNIFunctions{  
  jint (JNICALL *CreateJavaVM)(JavaVM **jvm, void **env, void *args);
  jint (JNICALL *GetCreatedJavaVMs)(JavaVM ** jvm, jsize bufLen, jsize *nVMs);
} JNIFunctions;

//////////////////////////////////////////////////////////////////////////////

class iJavaCPP
{
  
public:
  iJavaCPP();
  virtual ~iJavaCPP();

  // initialize and start up the VM
  virtual bool init(JavaVMOption *options, int nOptions);
  virtual void reset();

  // these are the system dependent functions and are the only
  // one an inheriting class needs to provide
  virtual bool getJNIFuncHandles() = 0;	
  virtual bool getJREHome(char *buf, int bufsize) = 0;
  virtual int getJVMType() = 0;	
 	
  // create Java side objects
  JObject *newObject(const char *className, const char *constuctorSig, ...);

  // member accessors
  JNIEnv *getEnv(){ return env; }
  JavaVM *getVM(){ return jvm; }

  bool isOK() const { return OK; }

  static const int JVM_HOTSPOT;
  static const int JVM_CLASSIC;
  static const int JVM_OTHER;	
  static const int JVM_NONE;	
	
  enum {MAXPATHLEN = 256};

protected:
  JNIFunctions jniFunctions;
  bool OK;
  JavaVM *jvm;
  JNIEnv *env;
  char jvmType[MAXPATHLEN];
  char jvmDll[MAXPATHLEN];
  char jreHome[MAXPATHLEN];
  JavaVMInitArgs vm_args;
};

//////////////////////////////////////////////////////////////////////////////

#endif // _I_JAVACPP_H__
